<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE sect1 PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
   "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
  <!ENTITY % general-entities SYSTEM "../../general.ent">
  %general-entities;

  <!ENTITY libxkbcommon-download-http "https://github.com/xkbcommon/libxkbcommon/archive/xkbcommon-&libxkbcommon-version;/libxkbcommon-xkbcommon-&libxkbcommon-version;.tar.gz">
  <!ENTITY libxkbcommon-download-ftp  " ">
  <!ENTITY libxkbcommon-md5sum        "e0bdc3555b3530d729d6d01afda52579">
  <!ENTITY libxkbcommon-size          "973 KB">
  <!ENTITY libxkbcommon-buildsize     "35 MB (with tests)">
  <!ENTITY libxkbcommon-time          "0.3 SBU (with tests)">
]>

<sect1 id="libxkbcommon" xreflabel="libxkbcommon-xkbcommon-&libxkbcommon-version;">
  <?dbhtml filename="libxkbcommon.html"?>


  <title>libxkbcommon-xkbcommon-&libxkbcommon-version;</title>

  <indexterm zone="libxkbcommon">
    <primary sortas="a-libxkbcommon-xkbcommon">libxkbcommon-xkbcommon</primary>
  </indexterm>

  <sect2 role="package">
    <title>Introduction to libxkbcommon-xkbcommon</title>

    <para>
      <application>libxkbcommon-xkbcommon</application> is a keymap compiler and
      support library which processes a reduced subset of keymaps as
      defined by the XKB specification.
    </para>

    &lfs122_checked;

    <bridgehead renderas="sect3">Package Information</bridgehead>
    <itemizedlist spacing="compact">
      <listitem>
        <para>
          Download (HTTP): <ulink url="&libxkbcommon-download-http;"/>
        </para>
      </listitem>
      <listitem>
        <para>
          Download (FTP): <ulink url="&libxkbcommon-download-ftp;"/>
        </para>
      </listitem>
      <listitem>
        <para>
          Download MD5 sum: &libxkbcommon-md5sum;
        </para>
      </listitem>
      <listitem>
        <para>
          Download size: &libxkbcommon-size;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated disk space required: &libxkbcommon-buildsize;
        </para>
      </listitem>
      <listitem>
        <para>
          Estimated build time: &libxkbcommon-time;
        </para>
      </listitem>
    </itemizedlist>
<!--
    <note>
      <para>
        The tarball
        <filename>libxkbcommon-&libxkbcommon-version;.tar.gz</filename> will
        extract to the directory
        <filename class="directory">libxkbcommon-xkbcommon-&libxkbcommon-version;.tar.gz</filename>.
      </para>
    </note>
-->
    <bridgehead renderas="sect3">libxkbcommon-xkbcommon Dependencies</bridgehead>

    <bridgehead renderas="sect4">Required</bridgehead>
    <para role="required">
      <xref role="runtime" linkend="xkeyboard-config"/> (runtime)
    </para>

    <bridgehead renderas="sect4">Recommended</bridgehead>
    <para role="recommended">
       <xref linkend="libxcb"/>,
       <xref linkend="wayland"/>, and
       <xref linkend="wayland-protocols"/>
    </para>

    <bridgehead renderas="sect4">Optional</bridgehead>
    <para role="optional">
      <xref linkend="doxygen"/> (for generating the documentation) and
      <command>Xvfb</command> (from
      <xref linkend='xorg-server'/> or
      <xref role='nodep' linkend='xwayland'/>)
    </para>

  </sect2>

  <sect2 role="installation">
    <title>Installation of libxkbcommon-xkbcommon</title>

    <para>
      Install <application>libxkbcommon</application> by running the following
      commands:
    </para>

<screen><userinput>mkdir build &amp;&amp;
cd    build &amp;&amp;

meson setup ..             \
      --prefix=/usr        \
      --buildtype=release  \
      -D enable-docs=false &amp;&amp;
ninja</userinput></screen>

    <para>
      To test the results, ensure <command>Xvfb</command> and
      <xref linkend='xkeyboard-config'/> are available, then issue:
      <command>ninja test</command>.
    </para>

    <para>
      Now, as the <systemitem class="username">root</systemitem> user:
    </para>

<screen role="root"><userinput>ninja install</userinput></screen>

  </sect2>

  <sect2 role="commands">
    <title>Command Explanations</title>

    <xi:include xmlns:xi="http://www.w3.org/2001/XInclude"
      href="../../xincludes/meson-buildtype-release.xml"/>

    <!--
    <xi:include xmlns:xi="http://www.w3.org/2001/XInclude"
      href="../../xincludes/static-libraries.xml"/>

    <para>
      <option>- -disable-x11</option>: Use this switch if you
      have not installed <xref linkend="libxcb"/> and
      don't need the <filename>libxkbcommon-x11.so</filename>
      library.
    </para>
    -->

    <para>
      <parameter>-D enable-docs=true</parameter>: This switch enables
      documentation generation. The <xref linkend="doxygen"/> is
      required.
    </para>

    <para>
      <command>mv -v /usr/share/doc/libxkbcommon{,-&libxkbcommon-version;}</command>:
      If you built the documentation, use this command to install 
      it in a versioned directory.
    </para>

  </sect2>

  <sect2 role="content">
    <title>Contents</title>

    <segmentedlist>
      <segtitle>Installed Programs</segtitle>
      <segtitle>Installed Libraries</segtitle>
      <segtitle>Installed Directories</segtitle>

      <seglistitem>
        <seg>
          xkbcli
        </seg>
        <seg>
          libxkbcommon.so,
          libxkbcommon-x11.so, and
          libxkbregistry.so
        </seg>
        <seg>
          /usr/include/xkbcommon,
          /usr/libexec/xkbcommon, and
          /usr/share/doc/libxkbcommon-&libxkbcommon-version;
        </seg>
      </seglistitem>
    </segmentedlist>

    <variablelist>
      <bridgehead renderas="sect3">Short Descriptions</bridgehead>
      <?dbfo list-presentation="list"?>
      <?dbhtml list-presentation="table"?>

      <varlistentry id="xkbcli">
        <term><command>xkbcli</command></term>
        <listitem>
          <para>
            provides a debugger and compiler for XKB keymaps
          </para>
          <indexterm zone="libxkbcommon xkbcli">
            <primary sortas="b-xkbcli">xkbcli</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="libxkbcommon-lib">
        <term><filename class="libraryfile">libxkbcommon.so</filename></term>
        <listitem>
          <para>
            contains the <application>libxkbcommon</application> API functions
          </para>
          <indexterm zone="libxkbcommon libxkbcommon-lib">
            <primary sortas="c-libxkbcommon">libxkbcommon.so</primary>
          </indexterm>
        </listitem>
      </varlistentry>

      <varlistentry id="libxkbcommon-x11">
        <term><filename class="libraryfile">libxkbcommon-x11.so</filename></term>
        <listitem>
          <para>
            contains the <application>libxkbcommon</application> X11 specific API
            functions
          </para>
          <indexterm zone="libxkbcommon libxkbcommon-x11">
            <primary sortas="c-libxkbcommon-x11">libxkbcommon-x11.so</primary>
          </indexterm>
        </listitem>
     </varlistentry>

     <varlistentry id="libxkbregistry">
       <term><filename class="libraryfile">libxkbregistry.so</filename></term>
       <listitem>
         <para>
           contains a list of available XKB models, layouts, and variants for a
           given ruleset
         </para>
         <indexterm zone="libxkbcommon libxkbregistry">
           <primary sortas="c-libxkbregistry">libxkbregistry.so</primary>
         </indexterm>
       </listitem>
     </varlistentry>

    </variablelist>

  </sect2>

</sect1>
